/* Logik-Rtsel nach A. Einstein */

nation(norweger).  % 9,13
nation(schwede). % 2 
nation(brite).   % 1
nation(dne).     % 3
nation(deutscher). % 14  
tier(hund).    % 2  
tier(vogel).   % 6  
tier(katze).   % 10  
tier(pferd).   % 11  
tier(fisch).    % Frage 
farbe(blau).   % 13  
farbe(rot).       % 1   
farbe(grn).     % 4,5 
farbe(wei).    % 4 
farbe(gelb).   % 8 
getrnk(milch).  % 7  
getrnk(tee).   % 3  
getrnk(kaffee). % 5  
getrnk(bier).   % 12  
getrnk(wasser). % 15  
zigar(pallmall). % 6    
zigar(dunhill).  % 8,11   
zigar(marlboro). % 10,15  
zigar(winfield).  % 12  
zigar(rothmanns). % 14  

nationen([N1,_,_,_,_],[N2,_,_,_,_],[N3,_,_,_,_],[N4,_,_,_,_],[N5,_,_,_,_]):-nation(N1),nation(N2),nation(N3),nation(N4),nation(N5),
     N1\=N2,N1\=N3,N1\=N4,N1\=N5,
     N2\=N3,N2\=N4,N2\=N5,
     N3\=N4,N3\=N5,N4\=N5.

farben([_,F1,_,_,_],[_,F2,_,_,_],[_,F3,_,_,_],[_,F4,_,_,_],[_,F5,_,_,_]):-farbe(F1),farbe(F2),farbe(F3),farbe(F4),farbe(F5),
     F1\=F2,F1\=F3,F1\=F4,F1\=F5,
     F2\=F3,F2\=F4,F2\=F5,
     F3\=F4,F3\=F5,F4\=F5.

 tiere([_,_,T1,_,_],[_,_,T2,_,_],[_,_,T3,_,_],[_,_,T4,_,_],[_,_,T5,_,_]):-tier(T1),tier(T2),tier(T3),tier(T4),tier(T5),
     T1\=T2,T1\=T3,T1\=T4,T1\=T5,
     T2\=T3,T2\=T4,T2\=T5,
     T3\=T4,T3\=T5,T4\=T5.
getrnke([_,_,_,G1,_],[_,_,_,G2,_],[_,_,_,G3,_],[_,_,_,G4,_],[_,_,_,G5,_]):-getrnk(G1),getrnk(G2),getrnk(G3),getrnk(G4),getrnk(G5),
     G1\=G2,G1\=G3,G1\=G4,G1\=G5,
     G2\=G3,G2\=G4,G2\=G5,
     G3\=G4,G3\=G5,G4\=G5.
zigaretten([_,_,_,_,F1],[_,_,_,_,F2],[_,_,_,_,F3],[_,_,_,_,F4],[_,_,_,_,F5]):-zigar(F1),zigar(F2),zigar(F3),zigar(F4),zigar(F5),
     F1\=F2,F1\=F3,F1\=F4,F1\=F5,
     F2\=F3,F2\=F4,F2\=F5,
     F3\=F4,F3\=F5,F4\=F5.

erscheint([N,F,T,G,Z],[N1,F1,T1,G1,Z1],[N2,F2,T2,G2,Z2],[N3,F3,T3,G3,Z3],[N4,F4,T4,G4,Z4],[N5,F5,T5,G5,Z5]):-
N=N1,F=F1,T=T1,G=G1,Z=Z1;
N=N2,F=F2,T=T2,G=G2,Z=Z2;
N=N3,F=F3,T=T3,G=G3,Z=Z3;
N=N4,F=F4,T=T4,G=G4,Z=Z4;
N=N5,F=F5,T=T5,G=G5,Z=Z5.

regel1(H1,H2,H3,H4,H5):-erscheint([brite,rot,_,_,_],H1,H2,H3,H4,H5).
regel2(H1,H2,H3,H4,H5):-erscheint([schwede,_,hund,_,_],H1,H2,H3,H4,H5).
regel3(H1,H2,H3,H4,H5):-erscheint([dne,_,_,tee,_],H1,H2,H3,H4,H5).

regel4([_,grn,_,_,_],[_,wei,_,_,_],_,_,_).
regel4(_,[_,grn,_,_,_],[_,wei,_,_,_],_,_).
regel4(_,_,[_,grn,_,_,_],[_,wei,_,_,_],_).
regel4(_,_,_,[_,grn,_,_,_],[_,wei,_,_,_]).

regel5(H1,H2,H3,H4,H5):-erscheint([_,grn,_,kaffee,_],H1,H2,H3,H4,H5).
regel6(H1,H2,H3,H4,H5):-erscheint([_,_,vogel,_,pallmall],H1,H2,H3,H4,H5).
regel7(_,_,[_,_,_,milch,_],_,_).
regel8(H1,H2,H3,H4,H5):-erscheint([_,gelb,_,_,dunhill],H1,H2,H3,H4,H5).
regel9([norweger,_,_,_,_],_,_,_,_).

regel10([_,_,katze,_,_],[_,_,_,_,marlboro],_,_,_).
regel10(_,[_,_,katze,_,_],[_,_,_,_,marlboro],_,_).
regel10(_,_,[_,_,katze,_,_],[_,_,_,_,marlboro],_).
regel10(_,_,_,[_,_,katze,_,_],[_,_,_,_,marlboro]).
regel10([_,_,_,_,marlboro],[_,_,katze,_,_],_,_,_).
regel10(_,[_,_,_,_,marlboro],[_,_,katze,_,_],_,_).
regel10(_,_,[_,_,_,_,marlboro],[_,_,katze,_,_],_).
regel10(_,_,_,[_,_,_,_,marlboro],[_,_,katze,_,_]).

regel11([_,_,pferd,_,_],[_,_,_,_,dunhill],_,_,_).
regel11(_,[_,_,pferd,_,_],[_,_,_,_,dunhill],_,_).
regel11(_,_,[_,_,pferd,_,_],[_,_,_,_,dunhill],_).
regel11(_,_,_,[_,_,pferd,_,_],[_,_,_,_,dunhill]).
regel11([_,_,_,_,dunhill],[_,_,pferd,_,_],_,_,_).
regel11(_,[_,_,_,_,dunhill],[_,_,pferd,_,_],_,_).
regel11(_,_,[_,_,_,_,dunhill],[_,_,pferd,_,_],_).
regel11(_,_,_,[_,_,_,_,dunhill],[_,_,pferd,_,_]).

regel12(H1,H2,H3,H4,H5):-erscheint([_,_,_,bier,winfield],H1,H2,H3,H4,H5).

regel13([norweger,_,_,_,_],[_,blau,_,_,_],_,_,_).
regel13(_,[norweger,_,_,_,_],[_,blau,_,_,_,_],_,_).
regel13(_,_,[norweger,_,_,_,_],[_,blau,_,_,_,_],_).
regel13(_,_,_,[norweger,_,_,_,_],[_,blau,_,_,_,_]).
regel13([_,blau,_,_,_,_],[norweger,_,_,_,_],_,_,_).
regel13(_,[_,blau,_,_,_,_],[norweger,_,_,_,_],_,_).
regel13(_,_,[_,blau,_,_,_,_],[norweger,_,_,_,_],_).
regel13(_,_,_,[_,blau,_,_,_,_],[norweger,_,_,_,_]).

regel14(H1,H2,H3,H4,H5):-erscheint([deutscher,_,_,_,rothmanns],H1,H2,H3,H4,H5).

regel15([_,_,_,_,marlboro],[_,_,_,wasser,_],_,_,_).
regel15(_,[_,_,_,_,marlboro],[_,_,_,wasser,_],_,_).
regel15(_,_,[_,_,_,_,marlboro],[_,_,_,wasser,_],_).
regel15(_,_,_,[_,_,_,_,marlboro],[_,_,_,wasser,_]).
regel15([_,_,_,wasser,_],[_,_,_,_,marlboro],_,_,_).
regel15(_,[_,_,_,wasser,_],[_,_,_,_,marlboro],_,_).
regel15(_,_,[_,_,_,wasser,_],[_,_,_,_,marlboro],_).
regel15(_,_,_,[_,_,_,wasser,_],[_,_,_,_,marlboro]).

lsung(H1,H2,H3,H4,H5):-nationen(H1,H2,H3,H4,H5),
			farben(H1,H2,H3,H4,H5),
			regel9(H1,H2,H3,H4,H5),
			regel13(H1,H2,H3,H4,H5),
			regel1(H1,H2,H3,H4,H5),
			getrnke(H1,H2,H3,H4,H5),
			regel7(H1,H2,H3,H4,H5),
			tiere(H1,H2,H3,H4,H5),
			regel2(H1,H2,H3,H4,H5),
			regel3(H1,H2,H3,H4,H5),
			regel4(H1,H2,H3,H4,H5),
			regel5(H1,H2,H3,H4,H5),
			zigaretten(H1,H2,H3,H4,H5),
			regel6(H1,H2,H3,H4,H5),
			regel8(H1,H2,H3,H4,H5),
			regel10(H1,H2,H3,H4,H5),
			regel11(H1,H2,H3,H4,H5),
			regel12(H1,H2,H3,H4,H5),
			regel14(H1,H2,H3,H4,H5),
			regel15(H1,H2,H3,H4,H5).