/* Krist, April 2003
SWI-PROLOG fr Logikrtsel:
Bringe die drei Lnder Frankreich, Schweiz, Deutschland mit ihren Hauptstdten und Autokennzeichen in eine bestimmte Reihenfolge:
*/

staat(deutschl).
staat(frankr).
staat(schweiz).

hauptst(berlin).
hauptst(bern).
hauptst(paris).

auto(ch).
auto(d).
auto(f).

lnder([L1,_,_],[L2,_,_],[L3,_,_]):-staat(L1),staat(L2),staat(L3),L1\=L2,L1\=L3,L2\=L3. % kein Name doppelt

haupt([_,L1,_],[_,L2,_],[_,L3,_]):-hauptst(L1),hauptst(L2),hauptst(L3),L1\=L2,L1\=L3,L2\=L3. % keine Stadt doppelt

kenn([_,_,L1],[_,_,L2],[_,_,L3]):-auto(L1),auto(L2),auto(L3),L1\=L2,L1\=L3,L2\=L3.     % kein Kennz. doppelt

lsung(L1,L2,L3):-lnder(L1,L2,L3),haupt(L1,L2,L3),kenn(L1,L2,L3),regel1(L1,L2,L3),regel2(L1,L2,L3),regel3(L1,L2,L3),regel4(L1,L2,L3).

% erscheint([X,Y,Z],[X,Y,Z]).




erscheint([X,Y,Z],[X1,Y1,Z1],[X2,Y2,Z2],[X3,Y3,Z3]):-
               X=X1,Y=Y1,Z=Z1;
               X=X2,Y=Y2,Z=Z2;
               X=X3,Y=Y3,Z=Z3.
             
% deutschl. hat d:
regel1(L1,L2,L3):-erscheint([deutschl,_,d],L1,L2,L3).

% paris hat f:
regel2(L1,L2,L3):-erscheint([_,paris,f],L1,L2,L3).

% schweiz hat bern:
regel3(L1,L2,L3):-erscheint([schweiz,bern,_],L1,L2,L3).

% drittes kennz ist d:
regel4(_,_,[_,_,d]).