/* Krist Mrz 2003 MERGE.PL  
   sortiert eine Liste nach MERGEsort
   Quelle: Mossakowski[1988]: Kap. 2.6.4
*/

mische([],L,L).
mische(L,[],L).
/* bernehme den kleineren Kopf der beiden Listen
   in die Ergebnisliste */
mische([K1|Rest1],[K2|Rest2],[K1|Restneu]) :-
   K1=<K2,
   mische(Rest1,[K2|Rest2],Restneu).
mische([K1|Rest1],[K2|Rest2],[K2|Restneu]) :-
   K1>K2,
   mische([K1|Rest1],Rest2,Restneu).

teile([],[],[]).
teile([X],[X],[]). /* einzelner Rest landet links */
teile([K1,K2|Rest],[K1|Rest1],[K2|Rest2]) :-
   teile(Rest,Rest1,Rest2).

mergesort([],[]).
mergesort([X],[X]).
mergesort([K1,K2|Rest],Sortiert) :-
   teile([K1,K2|Rest],T1,T2),
   mergesort(T1,S1),mergesort(T2,S2),
   mische(S1,S2,Sortiert).